import { Contract } from 'ethers';
import { TradeTick, IOHLCV } from 'candlestick-convert';
import { Timeframe } from '../enums';
export declare class Oracle {
    private contract;
    private metadata;
    constructor(_contract: Contract, _metadata: any);
    getTicks(): Promise<any>;
    getOHLCV(_timeframe: Timeframe): Promise<IOHLCV[]>;
    getOHLCVFromTicks(_ticks: TradeTick[], _timeframe: Timeframe): IOHLCV[];
    getContract(): Contract;
    getMetadata(): any;
    getTick(_time: BigInt, _price: BigInt, _quantity?: BigInt): TradeTick;
    validate(_metadata: any): void;
}
