import { Contract, Signer } from 'ethers';
import { TradeTick, IOHLCV } from 'candlestick-convert';
import { AbstractOracle } from './abstractOracle';
import { Timeframe } from '../../../enums';
import { Oracle } from '../../oracle';
export declare class OpenMarketsOracle extends Oracle implements AbstractOracle {
    private dataFeedId;
    constructor(_contract: Contract, _metadata: any);
    static initialize(_metadata: any, _signer: Signer): Promise<OpenMarketsOracle>;
    getLatestValue(): Promise<any>;
    getOHLCV(_timeframe: Timeframe): Promise<IOHLCV[]>;
    getTicks(): Promise<TradeTick[]>;
    validate(_metadata: any): void;
}
